import java.awt.image.BufferedImage;

public class MySpatialFilter3 {
	// ԃtB^O(3x3)sAډf̐FvZ郁\bh
	private static int getColor( MyBufferedImage0 img, int x, int y, double[] filter )
	{
		// ϐ̐錾
		double sum_r, sum_g, sum_b;
		double f;

		// ډf̐Fdefcolorɑ
		// W(x,y)摜ȌꍇAcolor0xffffffff(F)B
		int defcolor = img.getRGB( x, y, 0xffffffff );

		// ډf̐FvZ
		sum_r = sum_g = sum_b = 0.0;
		for ( int dy = -1; dy <= 1; dy++ ) {
			for ( int dx = -1; dx <= 1; dx++ ) {
				// ԃtB^̒l擾
				f = filter[ ( dx + 1 ) + ( dy + 1 ) * 3 ];

				// F擾
				// W(x+dx,y+dy)摜ȌꍇAcolordefcolor
				int color = img.getRGB( x + dx, y + dy, defcolor );

				// Fr,g,bɕ
				int r = ( color >> 16 ) & 0xff;
				int g = ( color >> 8 ) & 0xff;
				int b = color & 0xff;

				// RGBlɋԃtB^̒l|đ
				sum_r += (double)r * f;
				sum_g += (double)g * f;
				sum_b += (double)b * f;
			}
		}

		// vZRGB̒lꂼ0`255̒lɎ߂
		if ( 0.0 > sum_r ) sum_r = 0.0;
		if ( 255.0 < sum_r ) sum_r = 255.0;
		if ( 0.0 > sum_g ) sum_g = 0.0;
		if ( 255.0 < sum_g ) sum_g = 255.0;
		if ( 0.0 > sum_b ) sum_b = 0.0;
		if ( 255.0 < sum_b ) sum_b = 255.0;

		// RGB̒lĖ߂
		return ( (int)sum_r << 16 ) + ( (int)sum_g << 8 ) + (int)sum_b;
	}


	// C\bh
	public static void main(String[] args) {
		// t@C
		String inname, outname;

		// ԃtB^
		double filter[] = new double[ 9 ];

		// ͂11ȏォ𒲂ׂ
		if ( 11 > args.length ) {
			// ͂11̏ꍇAgp@\
			System.out.println( "MySpatialFilter3 [͉摜]  [oJPG]  k00  k01  k02  k10  k11  k12  k20  k21  k22" );
			return;
		}

		// ͉摜innameɑigqȗȂj
		inname  = args[ 0 ];
		// oJPGoutnameɑigq".jpg"ȗȂj
		outname = args[ 1 ];

		// ԃtB^̐ݒ
		for ( int i = 0; i < 9; ++ i ) {
			filter[ i ] = Double.parseDouble( args[ i + 2 ] );
		}

		// 摜NX쐬(摜i[p)
		MyBufferedImage0 img_src = new MyBufferedImage0();

		// 摜̓ǂݍ
		if ( !img_src.read( inname ) ) {
			System.out.println( "ǂݍ݂Ɏs܂I(" + inname +")" );
			return;
		}

		// ǂݍ񂾉摜̃TCY
		int w = img_src.getWidth();
		int h = img_src.getHeight();

		// 摜NX쐬(ϊ摜i[p)
		MyBufferedImage0 img_des = new MyBufferedImage0();
		if ( false == img_des.create( w, h, BufferedImage.TYPE_INT_RGB ) ) {
			System.out.println( "摜̍쐬Ɏs܂I" );
			return;
		}
	
		// ԃtB^O
		for ( int y = 0; y < h; y++ ) {
			for ( int x = 0; x < w; x++ ) {
				// F擾
				int color = getColor( img_src, x, y, filter );
				int r = MyBufferedImage0.getR( color );
				int g = MyBufferedImage0.getG( color );
				int b = MyBufferedImage0.getB( color );

				// ϊFݒ
				img_des.setRGB( x, y, r, g, b );
			}
		}

		// JPG摜̕ۑ
		if ( !img_des.writeJPG( outname ) ) {
			System.out.println( "ۑɎs܂I(" + outname +")" );
			return;
		}

		// ɏI
		System.out.println( "ɏI܂" );
	}
}